"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.RunApp = void 0;
const promises_1 = require("readline/promises");
const process_1 = require("process");
const utils_1 = require("./commands/utils");
const utils = __importStar(require("./utils"));
const cmds = __importStar(require("./commands"));
const RegisterCommands = () => {
    const commands = [
        cmds.help_command, cmds.set_command, cmds.unset_command, cmds.show_command,
        cmds.list_command, cmds.detail_command, cmds.fetch_command, cmds.create_command,
        cmds.save_command, cmds.load_command, cmds.clear_command
    ];
    return commands;
};
const ExcuteCommandIfExists = async (command, state, commands) => {
    // Get the command name and check that exists
    const cmd_name = command.split(" ")[0];
    const cmd_filter = commands.filter((value) => value.command === cmd_name);
    if (cmd_filter.length < 1) {
        const error_str = utils.FormatString("No Command: {0}", command);
        console.error(error_str);
        return state;
    }
    // Otherwise, get the actual command and obtain the matching groups
    const app_command = cmd_filter[0];
    const match = command.match(app_command.syntax);
    let data = match?.slice(1, match.length) || [];
    // Execute the command
    state = await app_command.callback(data, state);
    state.lastCommand = command;
    return state;
};
const RunApp = async () => {
    // First let's register all the commands
    const commands = RegisterCommands();
    // Initialize the app state
    let app_state = { commands: commands, variables: utils_1.app_variables };
    // Create the interface for reading the stdin
    const rl = (0, promises_1.createInterface)({ input: process_1.stdin, output: process_1.stdout });
    // Loop indefinitely up until the quit command is not given
    for (;;) {
        const answer = (await rl.question(">> (Type help for commands): ")).trim();
        if (answer.length < 1)
            continue; // Check that there is a command
        // Otherwise execute the command
        app_state = await ExcuteCommandIfExists(answer, app_state, commands);
        if (answer === 'quit') {
            break;
        }
    }
    rl.close();
};
exports.RunApp = RunApp;
