"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
const utils = __importStar(require("../utils"));
const lc = __importStar(require("../leetcode"));
const gqlQueries = __importStar(require("../queries"));
const DetailCommand = async (data, state) => {
    const is_local = data[1] === 'BYIDX' || data[1] === undefined;
    const problem_id = Number.parseInt(data[0]);
    // If local then fetch from local storage and print
    if (is_local) {
        console.log(state.lastSelectedProblems?.problemsetQuestionList[problem_id]);
        return state;
    }
    // Otherwise, fetch using the API
    const category = state.variables[0].value;
    const problems_data = await lc.FetchProblems({ category: category, limit: 1, skip: problem_id - 1 }, utils.FormatProblemsData, gqlQueries.problemListQuery);
    if (problems_data)
        console.log(problems_data.problemsetQuestionList[0]);
    return state;
};
// Detail Command - Retrieve more informations about a problem
const detail_command = {
    name: 'Detail Command',
    command: 'detail',
    syntax: /^detail\s+(\d+)(?:\s+(BYID|BYIDX))?$/,
    callback: DetailCommand,
    help: 'detail <ID/IDX> [BYID|BYIDX] - Print more details about a single problem.\n' +
        'The problem is specified either by "local" index, meaning among those that\n' +
        'were previously fetched using the `list` command, or by absolute problem Id.\n' +
        'IDX = local indexing, ID = Absolute problem ID. By default, if the second\n' +
        'is not specified, it is intended as IDX not ID.\n'
};
exports.default = detail_command;
