"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
const utils = __importStar(require("../utils"));
const HelpCommand = async (data, state) => {
    // First we need to filter the commands given the input ones
    const filter_result = state.commands.filter((value) => data.includes(value.command));
    const filter_commands = (data.length > 0) ? filter_result : state.commands;
    // Then we can just print for all resulting command the helper
    filter_commands.forEach((value) => {
        const separator_str = '-'.repeat(value.name.length);
        console.log(utils.FormatString("{0}\n{1}\n{2}", value.name, separator_str, value.help));
    });
    // Do not modify the state, but it must returns it
    return state;
};
// Help Command
const help_command = {
    name: 'Help Command',
    command: 'help',
    syntax: /\b\w+\b/g,
    callback: HelpCommand,
    help: 'help [cmd1 cmd2 ...] - Shows the helper string for each specified command.\n' +
        'If no command is specified, then consider all existing commands.\n',
};
exports.default = help_command;
