"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const IfNullUndefined = (data) => {
    if (data)
        return data;
    return undefined;
};
const LoadCommand = async (data, state) => {
    if (data.length < 1) {
        console.error("Missing the target filename");
        return state;
    }
    const filename = data[0];
    // Check that the provided file exists
    if (!fs.existsSync(filename)) {
        console.error(`File ${filename} does not exists`);
        return state;
    }
    const content = fs.readFileSync(filename, { encoding: 'utf-8' });
    const content_data = JSON.parse(content);
    // Modify the state with the loaded informations
    state.lastCommand = IfNullUndefined(content_data.lastCommand);
    state.lastQuestion = IfNullUndefined(content_data.lastQuestion);
    state.lastSelectedProblems = IfNullUndefined(content_data.lastSelectedProblems);
    state.selectedUser = IfNullUndefined(content_data.selectedUser);
    for (let i = 0; i < state.variables.length; i++) {
        state.variables[i].value = content_data.variables[i].value;
    }
    console.log("Loaded state from:", filename);
    return state;
};
// Load command - load the state from a json file
const load_command = {
    name: 'Load State Command',
    command: 'load',
    syntax: /^load\s+([\w/\.\-]+\.json)$/,
    callback: LoadCommand,
    help: 'load FILEPATH - Load the state from a json file\n'
};
exports.default = load_command;
