"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const SaveCommand = async (data, state) => {
    if (data.length < 1) {
        console.error("Missing the target filename");
        return state;
    }
    // Select the data to save into the json file
    const content_data = {
        lastCommand: state.lastCommand || null,
        lastSelectedProblems: state.lastSelectedProblems || null,
        lastQuestion: state.lastQuestion || null,
        selectedUser: state.selectedUser || null,
        variables: state.variables.map((x) => ({
            name: x.name,
            value: x.value
        }))
    };
    const filename = data[0]; // Take the filename from the data
    const content = JSON.stringify(content_data, null, 2);
    // Check if the parent path of the filename exists
    const parent = path.dirname(filename);
    if (!fs.existsSync(parent)) {
        if (fs.mkdirSync(parent, 0o777) === undefined) {
            console.error("Impossible to create parent path of provided file");
            return state;
        }
    }
    fs.writeFileSync(filename, content);
    console.log("Current state saved into:", filename);
    return state;
};
// Save command - Save the state into a json file
const save_command = {
    name: 'Save State Command',
    command: 'save',
    syntax: /^save\s+([\w/\.\-]+\.json)$/,
    callback: SaveCommand,
    help: 'save FILEPATH - Saves the current state into a json file\n'
};
exports.default = save_command;
